SystemOrganization addCategory: #'XPForums-Networking-Core'!
SystemOrganization addCategory: #'XPForums-Networking-Server'!

!Dictionary methodsFor: '*xpforums-networking-core' stamp: 'SR 9/9/2009 12:52'!
deserializeFrom: aStream
	aStream next. "$("
	[aStream peek = $)] whileFalse: [| key value |
		aStream next. "$<"
		key := aStream upToAll: '->'.
		value := aStream upTo: '>'.
		self add: key->value.
	].
	aStream next. "$)"! !

!Dictionary methodsFor: '*xpforums-networking-core' stamp: 'SR 9/9/2009 12:52'!
serializeOn: aStream
	aStream nextPut: $(.
	self keysSortedSafely do: [:key ||value|
		value := self at: key.
		value isString ifTrue: [value := value asHtml].
		aStream
			print: $<;
			print: key;
			nextPutAll: '->';				
			print: value;
			print: $>].
	aStream nextPut: $)! !

!WriteStream methodsFor: '*xpforums-networking' stamp: 'SR 9/8/2009 13:39'!
crlf
	"Append a return character to the receiver."

	self nextPut: Character cr.
	self nextPut: Character lf.! !

Object subclass: #XpfEntity
	instanceVariableNames: 'data uuid commandList'
	classVariableNames: 'EntityList'
	poolDictionaries: ''
	category: 'XPForums-Networking-Core'!

!XpfEntity class methodsFor: 'accessing' stamp: 'SR 9/8/2009 18:57'!
EntityList

	EntityList ifNil: [EntityList := Set new].
	^ EntityList! !

!XpfEntity methodsFor: 'commands' stamp: 'SR 9/8/2009 14:44'!
applyCommand: aCommand

	aCommand apply: self.
	self commandList add: aCommand.! !

!XpfEntity methodsFor: 'accessing' stamp: 'SR 9/8/2009 14:43'!
commandList

	^ commandList! !

!XpfEntity methodsFor: 'accessing' stamp: 'SR 9/8/2009 14:43'!
commandList: anObject

	commandList := anObject! !

!XpfEntity methodsFor: 'accessing' stamp: 'SR 9/8/2009 11:46'!
data

	^ data! !

!XpfEntity methodsFor: 'accessing' stamp: 'SR 9/8/2009 11:46'!
data: anObject

	data := anObject! !

!XpfEntity methodsFor: 'printing' stamp: 'SR 9/9/2009 13:11'!
deserializeFrom: stream

	| typeName |
	stream next. "${"
	typeName := stream upTo: '-'.
	type := (Smalltalk at: typeName asSymbol ifAbsent: [^ self]) new.	
	data := Dictionary new deserializeFrom: stream.
	stream next. "$}"! !

!XpfEntity methodsFor: 'initialization' stamp: 'SR 9/8/2009 14:43'!
initialize

	super initialize.
	
	self
		data: Dictionary new;
		commandList: OrderedCollection new.! !

!XpfEntity methodsFor: 'testing' stamp: 'SR 9/9/2009 13:27'!
isListEntity

	^ false! !

!XpfEntity methodsFor: 'printing' stamp: 'SR 9/8/2009 14:39'!
printOn: stream

	stream print: self uuid asString.! !

!XpfEntity methodsFor: 'printing' stamp: 'SR 9/9/2009 13:02'!
serializeOn: stream

	stream print: '{'.
	self type printOn: stream.
	stream print: '-'.
	self data serializeOn: stream.
	stream print: '}'.
	! !

!XpfEntity methodsFor: 'accessing' stamp: 'SR 9/8/2009 11:43'!
type

	^ type! !

!XpfEntity methodsFor: 'accessing' stamp: 'SR 9/8/2009 11:43'!
type: anObject

	type := anObject! !

!XpfEntity methodsFor: 'accessing' stamp: 'SR 9/8/2009 14:40'!
uuid

	uuid ifNil: [
		uuid := UUID new].
	^ uuid! !

!XpfEntity methodsFor: 'accessing' stamp: 'SR 9/8/2009 14:47'!
version

	^ self commandList size! !

XpfEntity subclass: #XpfListEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPForums-Networking-Core'!

!XpfListEntity class methodsFor: 'as yet unclassified' stamp: 'SR 9/9/2009 13:24'!
elementClass

	self subclassResponsibility! !

!XpfListEntity methodsFor: 'adding' stamp: 'SR 9/9/2009 13:41'!
add: aXpfObject

	(aXpfObject class = self class elementClass) ifFalse: [^ self].

	self data at: (self lastElement + 1) put: aXpfObject.
	self lastElement: self lastElement + 1.
	self size: self size + 1.	
	! !

!XpfListEntity methodsFor: 'adding' stamp: 'SR 9/9/2009 13:42'!
at: aNumber

	self data at: aNumber ifAbsent: [nil]! !

!XpfListEntity methodsFor: 'initialization' stamp: 'SR 9/9/2009 13:38'!
initialize

	super initialize.
	self data
		at: #size put: 0;
		at: #lastElement put: 0.! !

!XpfListEntity methodsFor: 'testing' stamp: 'SR 9/9/2009 13:27'!
isListEntity

	^ true! !

!XpfListEntity methodsFor: 'accessing' stamp: 'SR 9/9/2009 13:38'!
lastElement

	^ self data at: #lastElement ifAbsent: [0]! !

!XpfListEntity methodsFor: 'accessing' stamp: 'SR 9/9/2009 13:41'!
lastElement: aNumber

	self data at: #lastElement put: aNumber! !

!XpfListEntity methodsFor: 'accessing' stamp: 'SR 9/9/2009 13:37'!
size

	^ self data at: #size ifAbsent: [0]! !

!XpfListEntity methodsFor: 'accessing' stamp: 'SR 9/9/2009 13:41'!
size: aNumber

	self data at: #size put: aNumber! !

XpfListEntity subclass: #XpfProjectListEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPForums-Networking-Core'!

!XpfProjectListEntity class methodsFor: 'as yet unclassified' stamp: 'SR 9/9/2009 13:25'!
elementClass

	^ XpfProjectEntity! !

!XpfProjectListEntity methodsFor: 'initialization' stamp: 'SR 9/8/2009 15:37'!
initialize

	super initialize.
	self type: XpfRootListType.! !

!XpfProjectListEntity methodsFor: 'accessing' stamp: 'SR 9/8/2009 15:27'!
uuid

	^ UUID fromString: '00000000-0000-0000-0000-000000000002'! !

XpfListEntity subclass: #XpfUserListEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPForums-Networking-Core'!

!XpfUserListEntity class methodsFor: 'as yet unclassified' stamp: 'SR 9/9/2009 13:25'!
elementClass

	^ XpfUserEntity! !

!XpfUserListEntity methodsFor: 'initialization' stamp: 'SR 9/8/2009 15:37'!
initialize

	super initialize.
	self type: XpfRootListType.! !

!XpfUserListEntity methodsFor: 'accessing' stamp: 'SR 9/8/2009 15:27'!
uuid

	^ UUID fromString: '00000000-0000-0000-0000-000000000001'! !

XpfEntity subclass: #XpfProjectEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPForums-Networking-Core'!

XpfEntity subclass: #XpfUserEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPForums-Networking-Core'!

Object subclass: #XpfEntityCommand
	instanceVariableNames: 'data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPForums-Networking-Core'!

XpfEntityCommand subclass: #XpfCreateEntityCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPForums-Networking-Core'!

!XpfCreateEntityCommand methodsFor: 'as yet unclassified' stamp: 'SR 9/9/2009 13:27'!
apply: aXpfEntity

	aXpfEntity isListEntity
		ifFalse: [^ '403 Invalid Parameter']
		ifTrue: [ |newElement|
			newElement := aXpfEntity class elementClass new.
			aXpfEntity add: newElement.
			^ '250 ' + newElement uuid asString]! !

!XpfEntityCommand methodsFor: 'command-pattern' stamp: 'SR 9/8/2009 14:44'!
apply: aXpfEntity

	self subclassResponsibility! !

!XpfEntityCommand methodsFor: 'accessing' stamp: 'SR 9/9/2009 12:57'!
data

	^ data! !

!XpfEntityCommand methodsFor: 'accessing' stamp: 'SR 9/9/2009 12:57'!
data: anObject

	data := anObject! !

!XpfEntityCommand methodsFor: 'initialization' stamp: 'SR 9/9/2009 12:57'!
initialize

	super initialize.
	self data: Dictionary new.! !

!XpfEntityCommand methodsFor: 'command-pattern' stamp: 'SR 9/8/2009 14:44'!
revert: aXpfEntity

	self subclassResponsibility! !

XpfEntityCommand subclass: #XpfSetPrimitiveAttributeCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPForums-Networking-Core'!

!XpfSetPrimitiveAttributeCommand methodsFor: 'command-pattern' stamp: 'SR 9/8/2009 15:40'!
apply: XpfEntity

! !

Object subclass: #XpfEntityCommandFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPForums-Networking-Core'!

!XpfEntityCommandFactory class methodsFor: 'as yet unclassified' stamp: 'SR 9/9/2009 12:54'!
getCommandClassFromName: aString

	(aString = 'XpfCreateEntityCommand') ifTrue: [^ XpfCreateEntityCommand].
	(aString = 'XpfSetPrimitiveAttributeCommand') ifTrue: [^ XpfSetPrimitiveAttributeCommand].
	
	^ nil! !

!XpfEntityCommandFactory class methodsFor: 'as yet unclassified' stamp: 'SR 9/9/2009 12:56'!
getCommandFromString: aString

	| stream type parameter |
	stream := ReadStream on: aString.
	stream next. "{"
	type := self getCommandClassFromName: (stream upTo: '-').
	parameter := Dictionary new deserializeFrom: stream.
	
	^ type new data: parameter.
	
	
	! !

Object subclass: #XpfTcpCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPForums-Networking-Server'!

XpfTcpCommand subclass: #XpfTcpApplyCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPForums-Networking-Server'!

!XpfTcpApplyCommand class methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 14:55'!
verb

	^ 'apply'! !

!XpfTcpApplyCommand methodsFor: 'as yet unclassified' stamp: 'SR 9/9/2009 13:02'!
execute: line

	| uuid commandString command |
	[uuid := UUID fromString: (line truncateTo: 36).]
		on: Error
		do: [:ex| ^ '401 Parameter invalid'].
	
	commandString := line allButFirst: (37 min: line size).
	command := XpfEntityCommandFactory getCommandFromString: commandString.
	command ifNil: [^ '402 Parameter invalid'].
	
	XpfEntity EntityList do: [:e |
		e uuid = uuid ifTrue: [
			^ e applyCommand: command.]].
	^ '400 Not Found'! !

!XpfTcpCommand class methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 15:14'!
getCommandForLine: line

	self allSubclassesDo: [:subclass | 
		(line beginsWith: subclass verb) ifTrue: [
			^ subclass]].
	^ nil! !

!XpfTcpCommand class methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 14:55'!
verb

	^ self subclassResponsibility! !

!XpfTcpCommand methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 19:03'!
execute: line
	
	self subclassResponsibility! !

XpfTcpCommand subclass: #XpfTcpGetCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPForums-Networking-Server'!

!XpfTcpGetCommand class methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 14:55'!
verb

	^ 'get'! !

!XpfTcpGetCommand methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 19:08'!
execute: line

	| uuid |
	[uuid := UUID fromString: line.]
		on: Error
		do: [:ex| ^ '401 Parameter invalid'].
	XpfEntity EntityList do: [:e |
		e uuid = uuid ifTrue: [
			^ String streamContents: [:stream| 
				stream print: '250 '.
				e serializeOn: stream]]].
	^ '400 Not Found'! !

Object subclass: #XpfTcpTextServer
	instanceVariableNames: 'port listenSocket clientWorkerList listenProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPForums-Networking-Server'!

XpfTcpTextServer subclass: #XpfTcpCentralServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPForums-Networking-Server'!

!XpfTcpCentralServer methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 14:48'!
hasWelcomeBanner

	^ false! !

!XpfTcpCentralServer methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 19:01'!
initialize

	super initialize.
	self
		port: 54300;
		initializeEntityList.! !

!XpfTcpCentralServer methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 19:00'!
initializeEntityList

	XpfEntity EntityList isEmpty ifTrue: [
		XpfEntity EntityList
			add: XpfUserListEntity new;
			add: XpfProjectListEntity new].! !

!XpfTcpCentralServer methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 19:02'!
processLine: aString

	| command parameter |
	command := XpfTcpCommand getCommandForLine: aString.
	command ifNil: [^ ''].
	parameter := aString allButFirst: ((command verb size + 1) min: aString size).
	^ command new execute: parameter.! !

XpfTcpTextServer subclass: #XpfTcpEchoServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPForums-Networking-Server'!

!XpfTcpEchoServer methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 12:18'!
processLine: aString

	Transcript show: aString; cr.
	^ aString! !

!XpfTcpTextServer methodsFor: 'accessing' stamp: 'SR 9/8/2009 12:03'!
clientWorkerList

	^ clientWorkerList! !

!XpfTcpTextServer methodsFor: 'accessing' stamp: 'SR 9/8/2009 12:03'!
clientWorkerList: anObject

	clientWorkerList := anObject! !

!XpfTcpTextServer methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 13:25'!
hasWelcomeBanner

	^ false! !

!XpfTcpTextServer methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 12:03'!
initialize

	super initialize.
	Socket initializeNetwork.
	
	self
		port: 54320;
		clientWorkerList: OrderedCollection new.! !

!XpfTcpTextServer methodsFor: 'accessing' stamp: 'SR 9/8/2009 12:16'!
listenProcess

	^ listenProcess! !

!XpfTcpTextServer methodsFor: 'accessing' stamp: 'SR 9/8/2009 12:16'!
listenProcess: anObject

	listenProcess := anObject! !

!XpfTcpTextServer methodsFor: 'accessing' stamp: 'SR 9/8/2009 11:55'!
port

	^ port! !

!XpfTcpTextServer methodsFor: 'accessing' stamp: 'SR 9/8/2009 11:55'!
port: anObject

	port := anObject! !

!XpfTcpTextServer methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 11:53'!
processLine: aString

	self subclassResponsibility.! !

!XpfTcpTextServer methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 13:32'!
processSocket: aSocket
 	
	^ [| stream |      
		stream := SocketStream on: aSocket.
		
		self hasWelcomeBanner ifTrue: [
			stream nextPutAll: self welcomeBanner; crlf; flush].
	
	    	[aSocket notNil and: [stream isConnected]] whileTrue: [|data response|
	      	data := stream upToAll: String crlf.
			data = '.'
				ifTrue: [aSocket closeAndDestroy. response := nil]
				ifFalse: [response := self processLine: data].
			response isNil ifFalse: [
           		stream
             			nextPutAll: response;
             			crlf;
             			flush
			].
       	].
       	aSocket ifNotNil: [aSocket closeAndDestroy].
	] fork.! !

!XpfTcpTextServer methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 12:15'!
running

	^ self listenProcess isNil not! !

!XpfTcpTextServer methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 12:17'!
startServer

	| |
	self running ifTrue: [^ self].
	
	listenSocket := Socket newTCP.
	listenSocket listenOn: (self port) backlogSize: 4.
   	self listenProcess: (
		[
			[true] whileTrue: [ | socket |
				socket := listenSocket waitForAcceptFor: 60.
				self clientWorkerList add: (self processSocket: socket).
		
			]
		] fork).! !

!XpfTcpTextServer methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 12:17'!
stopServer

	self running ifFalse: [^ self].
	
	self listenProcess terminate.
	listenSocket closeAndDestroy.
	
	self clientWorkerList do: [:element |
		element isTerminated ifFalse: [element terminate]].! !

!XpfTcpTextServer methodsFor: 'as yet unclassified' stamp: 'SR 9/8/2009 13:25'!
welcomeBanner

	^ self subclassResponsibility! !
